//	Vray Elements to Photoshop importer v0.02
//	(badly) written by Øyvind Schei
//	www.ascantica.com

//----------------Settings!---------------
//Import layers as smart objects (set to 1 to use)
smart = 0;

//--Main script
var startRulerUnits = app.preferences.rulerUnits;
app.bringToFront();
app.preferences.rulerUnits = Units.PIXELS;
files = openDialog();
length = files.length;
layerName = new Array(length);
order = new Array();
count = 10;
for (var i=0;i<files.length;i++)
{
	files2 = files[i].toString();
	index = files2.lastIndexOf("/")+1;
	filename = files2.substr(index);
	search0 = filename.search(/diffuse/i);
	search1 = filename.search(/rawlighting/i);
	search2 = filename.search(/global_illum/i);
	search3 = filename.search(/reflection/i);
	search4 = filename.search(/refraction/i);
	search5 = filename.search(/caustics/i);
	search6 = filename.search(/specular/i);
	search7 = filename.search(/background/i);
	search8 = filename.search(/atmosphere/i);
	search9 = filename.search(/alpha/i);
	
	if (search0 > -1) {
		layerName[i] = "Diffuse";	
		order.push(0 + "-" + i);
	} else if (search1 > -1) {
		layerName[i] = "Raw Lighting";	
		order.push(1 + "-" + i);
	} else if (search2 > -1) {
		layerName[i] = "Global Illumination";	
		order.push(2 + "-" + i);
	} else if (search3 > -1) {
		layerName[i] = "Reflection";
		order.push(3 + "-" + i);
	} else if (search4 > -1) {
		layerName[i] = "Refraction";	
		order.push(4 + "-" + i);
	} else if (search5 > -1) {
		layerName[i] = "Caustics";	
		order.push(5 + "-" + i);
	} else if (search6 > -1) {
		layerName[i] = "Specular";	
		order.push(6 + "-" + i);
	} else if (search7 > -1) {
		layerName[i] = "Background";	
		order.push(7 + "-" + i);
	} else if (search8 > -1) {
		layerName[i] = "Atmosphere";	
		order.push(8 + "-" + i);
	} else if (search9 > -1) {
		layerName[i] = "Alpha";	
		order.push(9 + "-" + i);
	} else {
		layerName[i] = filename;	
		order.push(count + "-" + i);
		count++
	} 
}
function sortNumber(a, b)
{
divider = a.lastIndexOf("-");
a2 = a.substring(0,divider);
divider2 = b.lastIndexOf("-");
b2 = b.substring(0,divider2);
return a2 - b2
}
order.sort(sortNumber);
	//=================
for (var p=0;p<length;p++)
	{
	divider = order[p].lastIndexOf("-")+1;
	var sort = order[p].substr(divider);
	var layerName2 = layerName[sort];
	var fileRef = File(files[sort]);
	if (p == 0) { 
		var docRef = app.open(fileRef);
	} else {
	// ===========Insert picture
   var id14 = charIDToTypeID( "Plc " );
    var desc4 = new ActionDescriptor();
    var id15 = charIDToTypeID( "null" );
    desc4.putPath( id15, new File( fileRef ) );
    var id16 = charIDToTypeID( "FTcs" );
    var id17 = charIDToTypeID( "QCSt" );
    var id18 = charIDToTypeID( "Qcsa" );
    desc4.putEnumerated( id16, id17, id18 );
    var id19 = charIDToTypeID( "Ofst" );
        var desc5 = new ActionDescriptor();
        var id20 = charIDToTypeID( "Hrzn" );
        var id21 = charIDToTypeID( "#Pxl" );
        desc5.putUnitDouble( id20, id21, 0.000000 );
        var id22 = charIDToTypeID( "Vrtc" );
        var id23 = charIDToTypeID( "#Pxl" );
        desc5.putUnitDouble( id22, id23, 0.000000 );
    var id24 = charIDToTypeID( "Ofst" );
    desc4.putObject( id19, id24, desc5 );
executeAction( id14, desc4 );

// ===========Rasterize
if (smart == 0) {
var id35 = stringIDToTypeID( "rasterizeLayer" );
    var desc8 = new ActionDescriptor();
    var id36 = charIDToTypeID( "null" );
        var ref2 = new ActionReference();
        var id37 = charIDToTypeID( "Lyr " );
        var id38 = charIDToTypeID( "Ordn" );
        var id39 = charIDToTypeID( "Trgt" );
        ref2.putEnumerated( id37, id38, id39 );
    desc8.putReference( id36, ref2 );
executeAction( id35, desc8, DialogModes.NO );
}
// =========Change layer blendings
var id25 = charIDToTypeID( "setd" );
    var desc6 = new ActionDescriptor();
    var id26 = charIDToTypeID( "null" );
        var ref1 = new ActionReference();
        var id27 = charIDToTypeID( "Lyr " );
        var id28 = charIDToTypeID( "Ordn" );
        var id29 = charIDToTypeID( "Trgt" );
        ref1.putEnumerated( id27, id28, id29 );
    desc6.putReference( id26, ref1 );
    var id30 = charIDToTypeID( "T   " );
        var desc7 = new ActionDescriptor();
        var id31 = charIDToTypeID( "Md  " );
        var id32 = charIDToTypeID( "BlnM" );
		if (layerName2 == "Diffuse" || layerName2 == "Alpha") {
			var id33 = charIDToTypeID( "Nrml" );
		} else if (layerName2 == "Raw Lighting")  {
			var id33 = charIDToTypeID( "Mltp" );
		} else {
			var id33 = stringIDToTypeID( "linearDodge" );
		}
        desc7.putEnumerated( id31, id32, id33 );
    var id34 = charIDToTypeID( "Lyr " );
    desc6.putObject( id30, id34, desc7 );
executeAction( id25, desc6, DialogModes.NO );

// ========Change layer names
var id9 = charIDToTypeID( "setd" );
    var desc3 = new ActionDescriptor();
    var id10 = charIDToTypeID( "null" );
        var ref2 = new ActionReference();
        var id11 = charIDToTypeID( "Lyr " );
        var id12 = charIDToTypeID( "Ordn" );
        var id13 = charIDToTypeID( "Trgt" );
        ref2.putEnumerated( id11, id12, id13 );
    desc3.putReference( id10, ref2 );
    var id14 = charIDToTypeID( "T   " );
        var desc4 = new ActionDescriptor();
        var id15 = charIDToTypeID( "Nm  " );
        desc4.putString( id15, layerName2 );
    var id16 = charIDToTypeID( "Lyr " );
    desc3.putObject( id14, id16, desc4 );
executeAction( id9, desc3, DialogModes.NO );

// ===========hide layers
	if (layerName2 != "Raw Lighting" && layerName2 != "Global Illumination" && layerName2 != "Reflection" && layerName2 != "Refraction" && layerName2 != "Caustics" && layerName2 != "Specular" && layerName2 != "Background" && layerName2 != "Atmosphere")  {
	var id1153 = charIDToTypeID( "Hd  " );
    var desc287 = new ActionDescriptor();
    var id1154 = charIDToTypeID( "null" );
        var list78 = new ActionList();
            var ref231 = new ActionReference();
            var id1155 = charIDToTypeID( "Lyr " );
            var id1156 = charIDToTypeID( "Ordn" );
            var id1157 = charIDToTypeID( "Trgt" );
            ref231.putEnumerated( id1155, id1156, id1157 );
        list78.putReference( ref231 );
    desc287.putList( id1154, list78 );
	executeAction( id1153, desc287, DialogModes.NO );
	}
	}
}

// Reset the application preferences
app.preferences.rulerUnits = startRulerUnits;